#include "TmyList.h"

void
TmyList::InsertElement(
	int 			key				// data to be inserted
)
{
	fNumOps++;

	TrecordMemoryAddress ptr = fRecordPool.NextFreeRecord(fHeadPointer);
	if (ptr != kNullAddress) {
		fRecordPool.SetKeyField(ptr, key);
		fRecordPool.SetNextField(ptr, fHeadPointer);
		fHeadPointer = ptr;
	} else {
		cout << "**** WARNING ****: Out of memory: List insertion of " << key << " failed!!" << endl;
	}
}

bool
TmyList::RemoveLinkFromList(
	int 			key					// link containing this data will be removed
)
	//
	// if key is found in the list, the link containing
	// the key is removed from the list, returns true/false
	// depending on if deletion is successful
	//
	// if key is not found, an invalid address is returned.
	// and the content of the list is not altered.
	//
{

	TmyListIterator iterator(*this);

	fNumOps++;

	TrecordMemoryAddress prePtr = fHeadPointer;
	bool found = false;

	while ( iterator.NotEndOfList() && (!found) ) {

		TrecordMemoryAddress link = iterator.GetLink();

		if ( key==iterator.GetKey() ) {
			found = true;
			if (link == fHeadPointer) {
				//
				// the very first element
				// 
				fHeadPointer = fRecordPool.NextField(link);
			} else {
				fRecordPool.SetNextField(prePtr,fRecordPool.NextField(link));
			}
		}

		//
		// keep track of the pre-entry for 
		// list deletion
		//
		prePtr = link;
		iterator.IterateToNext();
	}

	return found;
}


void
TmyList::PrintListContent(const char *listName)
{
	int key;

	TmyListIterator iterator(*this);

	TrecordMemoryAddress current, next;

	cout << "After: " << fNumOps 
	 	 << " Operations: content of " 
		 << listName << "-List: Head(" << fHeadPointer << ")" << endl;

	while (iterator.NotEndOfList()) {

		current = iterator.GetLink();

		next = fRecordPool.NextField(current);
		key = iterator.GetKey();

		cout << "	RecordAdddress("   <<  setw(2) << current 
			 << ")  Key=("              << setw(5) << key
			 << ") NextRecordAddress= " << setw(2) << next << endl;

		iterator.IterateToNext();
	}
}
