#include "TrecordMemoryPool.h"
#include "TmyList.h"

#include "../PrintThread/TprintListThread.h"

#define kPrintWorkTime	2

	//
	// To see the problem: i 
	//					   1 2 3 4 5 -1  <- inserted 1 2 3 4 5
	//				  	   p			 <- now print
	//		immidiately:   d 5  <- delete 5
	//
	//     now, should printList printed out "5" or not?
	//					
	
int main(int argc, char *argv) 
{

	TrecordMemoryPool pool;
	TmyList	          myList(pool);

	TprintListThread pt("PrintList", myList, kPrintWorkTime);


	char command[256];
	int  inputNum;


	command[0] = 'n';
	while (command[0] != 'q') {
		cout << "\nYour Command [i d p f g s]? ";
		cin >> command;

		switch (command[0]) {
			case 'i':
					//
					// insert until we see -1
					//
					cout << "Please enter integers to be inserted (-1 to stop)" << endl;
					cin >> inputNum;
					while (inputNum >= 0) {
						myList.InsertElement(inputNum);
						cin >> inputNum;
					}
					break;

			case 'd':
					{
						//
						// enter one element and delete
						//
						cout << "Please enter the key to delete: ";
						cin >> inputNum;

						if ( myList.RemoveLinkFromList(inputNum) ) {
							cout <<  "Deleted Key(" << inputNum << ")" << endl;
						} else  {
							cout << "Input: [" << inputNum << "] is not in the list!" << endl;
						}

						break;
					}

			case 'p':
					//
					// print the keys in the list, then print the 
					// content of the list;
					// myList.PrintListContent("myList");
					//
					// instead of calling list's print routine, we will start a
					// new thread to start the printing, notice, the advantage
					// of doing this is, if printing takes a long time, we can
					// free up our program to do something else ... 
					//
					{
						pt.StartThread();
					}
					break;
			
			case 'g':
					//
					// force a garbage collection
					cout << "Forcing a garbage collection!\n";
					pool.GarbageCollection(myList.HeadOfList());
					break;
			
			case 'f':
					//
					// print record pool
					cout << "Here is the Record Pool:" << endl;
					pool.PrintRecordMemoryPool();
					break;

			case 's':
					//
					// 
					cout <<  "I did not implement list-based mergeSort\n";
					cout <<  "BUT ... you should!\n";
					break;

			default:
					break;
		}
	}
	
	return 0;
}
