//////////////////////////////////////////////////
// File: TprintListThread.cpp
// Author: Kelvin Sung
// Date: April 2003
// 
//    Starts a thread to print TmyList.
//	  Waits ThreadWorkTime() before terminates the thread.
//
//
//
#include "TprintListThread.h"

#include <process.h>
			// for _beginthread and _endthread

#include <iostream.h>
#include <iomanip.h>

#include <windows.h>
			// for Sleep


static void PrintMyListThread(void *parm)
{
	TprintListThread *pt = (TprintListThread *) parm;
	ofstream &os = pt->OutStream();
	

	////////////////////////////////////////////////////////////
	// MAKE SURE: you call ThreadWorkTime() **** BEFORE ****
	// you enter your original list routine.
	////////////////////////////////////////////////////////////
	pt->ThreadWorkTime();



		//////////////////////////////////////////////////////////////
		// The following is my original list printing routine
		///////////////////////////////////////////////////////////////
		TmyListIterator it(*(pt->GetList()));

		os << "Printing TmyList: " << endl;
		while ( it.NotEndOfList() ) {
			TrecordMemoryAddress link = it.GetLink();
			int	key = it.GetKey();		
			os << "Link(" << link << ") Has Key(" << key << ")" << endl;
					// You usually will not do this,
					// I am doing this here to just make
					// sure, we take a long time to traverse
					// the link list ...
					Sleep(1000);	// this is holding one second
					//
					//
			it.IterateToNext();
		}
		//////////////////////////////////////////////////////////////
		// This is the end of my original list printing routine
		///////////////////////////////////////////////////////////////


	pt->ThreadWorkTime();
	////////////////////////////////////////////////////////////
	// MAKE SURE: you call ThreadWorkTime() **** RIGHT AFTER ****
	// your original list routine. and BEFORE you announce your
	// are done with your work.
	////////////////////////////////////////////////////////////


	cerr << "Thread: [" << pt->ThreadName() << "]: Printing Done!" << endl;
	_endthread();

}

///////////////////////////////////////////////////////////////////////////////////////
//
// TprintListThread methods
//
/////////////////////////////////////////////////////////////////////////////////////
void
TprintListThread::StartThread()
{
	_beginthread(PrintMyListThread, 0, (void *) this );
}

